#include "boxnode.h"
#include <GL/gl.h>

BoxNode::BoxNode(std::string name, GLclampf red, GLclampf green, GLclampf blue) : GeometryNode(name)
{
    this->red = red;
    this->green = green;
    this->blue = blue;
}


void BoxNode::applySelf(){
     glColor3d(red, green, blue);
     GLdouble vertices[] = {-0.5,   0.5,    0.5,
                            -0.5,   -0.5,   0.5,
                            0.5,    -0.5,   0.5,
                            0.5,    0.5,    0.5,
                            -0.5,   0.5,    -0.5,
                            -0.5,   -0.5,   -0.5,
                            0.5,    -0.5,   -0.5,
                            0.5,    0.5,    -0.5
                        };

    // Vertex Array + Indices
    GLubyte indices[] = {0,1,2,3, // front
                         3,2,6,7, // right
                         7,6,5,4, // back
                         4,5,1,0, // left
                         0,3,7,4, // top
                         2,1,5,6
                     };
    glEnableClientState(GL_VERTEX_ARRAY);
    glVertexPointer(3, GL_DOUBLE, 0, vertices);
    glDrawElements(GL_QUADS,24,GL_UNSIGNED_BYTE, indices);
    glDisableClientState(GL_VERTEX_ARRAY);

}
