#ifndef NODE_H
#define NODE_H
#include <vector>
#include <string>

class Node
{

public:
    Node(std::string name = "Node");
    virtual ~Node();
    Node* getParent();

    std::vector<Node*> getChildren();
    void addChild(Node *child);
    std::string getType();
    std::string getName();
    void apply();
    void print(int indent = 0);
    void removeChild(Node* child);
    Node* findChildNodeByName(const std::string& nodeName);


protected:
    std::string name;
    std::string type;
    Node *parent;
    std::vector<Node*> children;
    void setParent(Node*);
    virtual void applySelf();

private:


};

#endif // NODE_H
