#include "transformnode.h"
#include <iostream>
#include <iomanip>

TransformNode::TransformNode(std::string name) : Node(name){
    this->type = "TransformNode";
    matrix = new GLdouble[16];
    // initialize unity matrix
    for (int i = 0; i < 16; i++){
        matrix[i] = 0.0;
    }
    matrix[0*4 + 0] = matrix[1*4 + 1] = matrix[2*4 + 2] = matrix[3*4 + 3] =  1;

}

TransformNode::~TransformNode(){
    delete matrix;
}

void TransformNode::applySelf(){
    glMultMatrixd(matrix);
}

void TransformNode::applyInverse(){
    GLdouble* inverse = new GLdouble[16];
    for (int i=0; i<12; i++)
    {
        inverse[i] = matrix[i];
    }

    inverse[12] = -matrix[12];
    inverse[13] = -matrix[13];
    inverse[14] = -matrix[14];
    inverse[15] = 1;

    glMultMatrixd(inverse);
    delete inverse;
}

void TransformNode::printMatrix(GLdouble* mat){
    std::cout << std::fixed;
    for (int i = 0; i < 4; i++){
        for (int j = 0; j < 4; j++){
            std::cout << std::setprecision(0) << mat[j*4 + i];
        }
        std::cout << std::endl;
    }
    std::cout << std::endl;
}

GLdouble* TransformNode::get()
{
    return matrix;
}
